#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <time.h>
#include <jni.h>

#include <android/log.h>

#define COLOR_RGB(r, g, b) ((r << 24) + (g << 16) + b)

JNIEXPORT void JNICALL Java_com_example_android_livewallpaper2_FireEffect_effect
		(JNIEnv *env, jobject thiz, jint fireLevel, jint width, jint height, jintArray imageArray, jintArray palletArray, jintArray seedparamArray, jintArray colorArray) {
	int i, j;
	jclass clazz = (*env)->FindClass(env, "com/example/android/livewallpaper2/FireEffect");
	jfieldID boostID = (*env)->GetStaticFieldID(env, clazz, "boost", "I");
	jint boost = (*env)->GetStaticIntField(env, clazz, boostID);
	jint *image = (*env)->GetIntArrayElements(env, imageArray, NULL);
	jint *pallet = (*env)->GetIntArrayElements(env, palletArray, NULL);
	jint *seedparam = (*env)->GetIntArrayElements(env, seedparamArray, NULL);
	jint *color = (*env)->GetIntArrayElements(env, colorArray, NULL);
	
	for (i = 0; i < width * height; i++) {
		if (seedparam[i] != 0 && seedparam[i] > (jint)((fireLevel - boost) * (abs(rand()) / (double)INT_MAX))) {
			pallet[i] = 127;
		} else if (seedparam[i] != 0) {
			pallet[i] = 0;
		}
	}
	if (boost > 0) {
		boost--;
	}
	
	for (i = 1; i < height - 1; i++) {
		for (j = 1; j < width - 1; j++) {
			pallet[(i - 1) * width + j] = (pallet[i * width + j] + 
					pallet[i * width + j - 1] + 
					pallet[i * width + j + 1] + 
					pallet[(i - 1) * width + j] + 
					pallet[(i + 1) * width + j]) / 5;
		}
	}
	
	for (i = 0; i < width * height; i++) {
		image[i] = color[pallet[i]];
	}
	(*env)->SetStaticIntField(env, clazz, boostID, boost);
	(*env)->ReleaseIntArrayElements(env, imageArray, image, 0);
	(*env)->ReleaseIntArrayElements(env, palletArray, pallet, 0);
	(*env)->ReleaseIntArrayElements(env, seedparamArray, seedparam, JNI_ABORT);
	(*env)->ReleaseIntArrayElements(env, colorArray, color, JNI_ABORT);
}

JNIEXPORT jstring JNICALL Java_com_example_android_livewallpaper2_FireEffect_hello
		(JNIEnv *env, jobject thiz) {
	__android_log_print(ANDROID_LOG_DEBUG, "JNI", "Hello, NDK");
	return (*env)->NewStringUTF(env, "Hello, NDK");
}
